name: Docker Build and Publish

on:
  push:
    branches: [ "main" ]
    paths-ignore:
      - '**/README.md'
  workflow_dispatch:

jobs:
  build-and-push-docker-image:
    name: Build Docker image and publish to Gitea
    runs-on: ubuntu-latest
    permissions:
      contents: read
      packages: write
      id-token: write

    steps:
      - name: Checkout repository
        uses: actions/checkout@v4

      - name: Setup Docker buildx
        uses: docker/setup-buildx-action@v3

      - name: Login to Gitea Container Registry
        uses: docker/login-action@v3
        with:
          registry: git.sdgarren.com
          username: ${{ secrets.REGISTRY_USERNAME }}
          password: ${{ secrets.REGISTRY_TOKEN }}

      - name: Build and push Docker image
        id: build-and-push
        uses: docker/build-push-action@v5
        with:
          provenance: false
          context: .
          platforms: linux/amd64
          push: true
          tags: |
            git.sdgarren.com/scott/usb-crash-cart:latest

      - name: Image digest
        run: echo ${{ steps.build-and-push.outputs.digest }}
